<script lang="ts">
	import { fade } from 'svelte/transition';
	import { onDestroy, onMount } from 'svelte';

	const props = $$props;
	let resolve;

	export const promise = new Promise((fulfil) => (resolve = fulfil));

	let active = false;
	onDestroy(() => {
		active = false;
	});

	onMount(() => {
		setTimeout(() => {
			active = true;
		}, 100);
	});

	function clickOutside(element, callbackFunction) {
		function onClick(event) {
			if (!element.contains(event.target)) {
				callbackFunction();
			}
		}

		document.body.addEventListener('click', onClick);

		return {
			update(newCallbackFunction) {
				callbackFunction = newCallbackFunction;
			},
			destroy() {
				document.body.removeEventListener('click', onClick);
			}
		};
	}
</script>

<svelte:head>
	<style>
		#circle2 {
			display: block;
			position: absolute;
			top: 50%;
			left: 50%;
			height: 50px;
			width: 50px;
			margin: -25px 0 0 -25px;
			border: 4px #ffff solid;
			border-top: 4px black solid;
			border-radius: 50%;
			-webkit-animation: spin2 1s infinite linear;
			animation: spin2 1s infinite linear;
		}

		@-webkit-keyframes spin2 {
			from {
				-webkit-transform: rotate(0deg);
				transform: rotate(0deg);
			}
			to {
				-webkit-transform: rotate(359deg);
				transform: rotate(359deg);
			}
		}
		@keyframes spin2 {
			from {
				-webkit-transform: rotate(0deg);
				transform: rotate(0deg);
				-webkit-transform: rotate(0deg);
				transform: rotate(0deg);
			}
			to {
				-webkit-transform: rotate(359deg);
				transform: rotate(359deg);
				-webkit-transform: rotate(359deg);
				transform: rotate(359deg);
			}
		}
	</style>
</svelte:head>

{#if active}
	<div class="flex justify-center h-full items-center">
		<div
			in:fade={{ duration: 250 }}
			out:fade={{ duration: 250 }}
			class="w-full h-screen fixed block top-0 bg-gray-900 bg-opacity-90 z-50"
		>
			<div
				use:clickOutside={() => (active = false)}
				class="flex mx-10 sm:mx-auto sm:px-10 sm:w-96 mt-28 sm:mt-32 flex-col items-center bg-white rounded"
			>
				<div
					class="flex-col md:flex-row justify-between  flex gap-4 items-start mx-4 py-2 sm:py-12"
				>
					<div class="flex justify-center items-center w-full h-full">
						<div class="flex">
							{@html props['html']}
						</div>
					</div>
				</div>
				<div class="px-5 py-2 border-t w-full flex justify-center">
					<button
						on:click={() => {
							active = false;
							resolve('confirm');
						}}
						class="bg-gree-400 rounded px-3 py-2 bg-indigo-700 hover:bg-indigo-800 text-white"
						>ตกลง</button
					>
				</div>
			</div>
		</div>
	</div>
{/if}
